# HG changeset patch
# User Barbara Locsi <locsi.barbara@gmail.com>
# Date 1469034897 -7200
#      Wed Jul 20 19:14:57 2016 +0200
# Node ID fa85bd7065f3e86d08d655be392ba0ffcbf3a68a
# Parent  ba8a9d2934c7c20e427a72f5101514aa53a87249
Generalised eigenvalue problem

diff -r ba8a9d2934c7 -r fa85bd7065f3 libinterp/corefcn/__qp__.cc
--- a/libinterp/corefcn/__qp__.cc	Mon Jul 18 13:52:57 2016 +0200
+++ b/libinterp/corefcn/__qp__.cc	Wed Jul 20 19:14:57 2016 +0200
@@ -148,7 +148,7 @@ qp (const Matrix& H, const ColumnVector&
     }
 
   ColumnVector eigenvalH = real (eigH.eigenvalues ());
-  Matrix eigenvecH = real (eigH.eigenvectors ());
+  Matrix eigenvecH = real (eigH.right_eigenvectors ());
   double minReal = eigenvalH.min ();
   octave_idx_type indminR = 0;
   for (octave_idx_type i = 0; i < n; i++)
@@ -296,7 +296,7 @@ qp (const Matrix& H, const ColumnVector&
                 }
 
               ColumnVector eigenvalrH = real (eigrH.eigenvalues ());
-              Matrix eigenvecrH = real (eigrH.eigenvectors ());
+              Matrix eigenvecrH = real (eigrH.right_eigenvectors ());
               double mRrH = eigenvalrH.min ();
               indminR = 0;
               for (octave_idx_type i = 0; i < n; i++)
diff -r ba8a9d2934c7 -r fa85bd7065f3 libinterp/corefcn/eig.cc
--- a/libinterp/corefcn/eig.cc	Mon Jul 18 13:52:57 2016 +0200
+++ b/libinterp/corefcn/eig.cc	Wed Jul 20 19:14:57 2016 +0200
@@ -52,7 +52,7 @@ The eigenvalues returned by @code{eig} a
 {
   int nargin = args.length ();
 
-  if (nargin > 2 || nargin == 0)
+  if (nargin > 4 || nargin == 0)
     print_usage ();
 
   octave_value_list retval;
@@ -75,7 +75,61 @@ The eigenvalues returned by @code{eig} a
   if (! arg_a.is_double_type () && ! arg_a.is_single_type ())
     err_wrong_type_arg ("eig", arg_a);
 
-  if (nargin == 2)
+  if (nr_a != nc_a)
+    err_square_matrix_required ("eig", "A");
+  
+  bool balance = true;
+  bool force_qz = false;
+  bool v_flag = false;
+  bool m_flag = false;
+  bool b_flag = false;
+  bool nb_flag = false;
+  
+  // determine if it's AEP or GEP
+  bool AEPcase = nargin == 1 || args(1).is_string ();
+  
+  if (AEPcase)
+    {
+      if (nargin == 2)
+        {
+          std::string a1s = args(1).string_value ();
+          if (a1s != "balance" && a1s != "nobalance" && a1s!="vector" && a1s!="matrix")
+            error ("eig: unexpected second input: %s", a1s.c_str ());
+          b_flag = a1s == "balance";
+          nb_flag = a1s == "nobalance";
+          v_flag = a1s == "vector";
+          m_flag = a1s == "matrix";
+        }
+      if (nargin == 3)
+        {
+          std::string a1s = args(1).string_value ();
+          if (a1s != "balance" && a1s != "nobalance" && a1s!="vector" && a1s!="matrix")
+            error ("eig: unexpected second input: %s", a1s.c_str ());
+          if (!args(2).is_string ())
+            err_wrong_type_arg ("eig", args(2));
+          
+          std::string a2s = args(2).string_value ();
+          if (a2s != "balance" && a2s != "nobalance" && a2s!="vector" && a2s!="matrix")
+            error ("eig: unexpected third input: %s", a2s.c_str ());
+          b_flag = a1s == "balance" || a2s == "balance";
+          nb_flag = a1s == "nobalance" || a2s == "nobalance";
+          v_flag = a1s == "vector" || a2s == "vector";
+          m_flag = a1s == "matrix" || a2s == "matrix";
+        }
+      if (nargin == 4)
+        {
+          if (!args(2).is_string ())
+            err_wrong_type_arg ("eig", args(2));
+          std::string a2s = args(2).string_value ();
+          if (a2s != "balance" && a2s != "nobalance" && a2s!="vector" && a2s!="matrix")
+            error ("eig: unexpected third input: %s", a2s.c_str ());
+          std::string a3s = args(3).string_value ();
+          if (a3s != "balance" && a3s != "nobalance" && a3s!="vector" && a3s!="matrix")
+            error ("eig: unexpected fourth input: %s", a3s.c_str ());
+        }
+
+    }
+  else
     {
       arg_b = args(1);
       nr_b = arg_b.rows ();
@@ -89,14 +143,48 @@ The eigenvalues returned by @code{eig} a
 
       if (! arg_b.is_single_type () && ! arg_b.is_double_type ())
         err_wrong_type_arg ("eig", arg_b);
+      if (nargin == 3)
+        {
+          if (!args(2).is_string ())
+            err_wrong_type_arg ("eig", args(2));
+          std::string a2s = args(2).string_value ();
+          if (a2s != "chol" && a2s != "qz" && a2s!="vector" && a2s!="matrix")
+            error ("eig: unexpected third input: %s", a2s.c_str ());
+          force_qz = a2s == "qz";
+          v_flag = a2s == "vector";
+          m_flag = a2s == "matrix";
+        }
+      if (nargin == 4)
+        {
+          if (!args(2).is_string ())
+            err_wrong_type_arg ("eig", args(2));
+          std::string a2s = args(2).string_value ();
+          if (a2s != "chol" && a2s != "qz" && a2s!="vector" && a2s!="matrix")
+            error ("eig: unexpected third input: %s", a2s.c_str ());
+          
+          if (!args(3).is_string ())
+            err_wrong_type_arg ("eig", args(3));
+          std::string a3s = args(3).string_value ();
+          if (a3s != "chol" && a3s != "qz" && a3s!="vector" && a3s!="matrix")
+            error ("eig: unexpected fourth input: %s", a3s.c_str ());
+          
+          force_qz = a2s == "qz" || a3s == "qz";
+          v_flag = a2s == "vector" || a3s == "vector";
+          m_flag = a2s == "matrix" || a3s == "matrix";
+        }
     }
-
-  if (nr_a != nc_a)
-    err_square_matrix_required ("eig", "A");
-
-  if (nargin == 2 && nr_b != nc_b)
+  
+  if (b_flag && nb_flag)
+    error ("eig: the combination of flags is invalid.");
+  if (v_flag && m_flag)
+    error ("eig: the combination of flags is invalid.");
+  if (nb_flag)
+    balance = false;
+  
+    
+  if (! AEPcase && nr_b != nc_b)
     err_square_matrix_required ("eig", "B");
-
+  
   Matrix tmp_a, tmp_b;
   ComplexMatrix ctmp_a, ctmp_b;
   FloatMatrix ftmp_a, ftmp_b;
@@ -105,99 +193,149 @@ The eigenvalues returned by @code{eig} a
   if (arg_a.is_single_type ())
     {
       FloatEIG result;
-
-      if (nargin == 1)
+      if (AEPcase)
         {
           if (arg_a.is_real_type ())
             {
               ftmp_a = arg_a.float_matrix_value ();
 
-              result = FloatEIG (ftmp_a, nargout > 1);
+              result = FloatEIG (ftmp_a, nargout > 1, nargout > 2, balance);
             }
           else
             {
               fctmp_a = arg_a.float_complex_matrix_value ();
 
-              result = FloatEIG (fctmp_a, nargout > 1);
+              result = FloatEIG (fctmp_a, nargout > 1, nargout > 2, balance);
             }
         }
-      else if (nargin == 2)
+      else
         {
           if (arg_a.is_real_type () && arg_b.is_real_type ())
             {
               ftmp_a = arg_a.float_matrix_value ();
               ftmp_b = arg_b.float_matrix_value ();
 
-              result = FloatEIG (ftmp_a, ftmp_b, nargout > 1);
+              result = FloatEIG (ftmp_a, ftmp_b, nargout > 1, nargout > 2, force_qz);
             }
           else
             {
               fctmp_a = arg_a.float_complex_matrix_value ();
               fctmp_b = arg_b.float_complex_matrix_value ();
 
-              result = FloatEIG (fctmp_a, fctmp_b, nargout > 1);
+              result = FloatEIG (fctmp_a, fctmp_b, nargout > 1, nargout > 2, force_qz);
             }
         }
 
       if (nargout == 0 || nargout == 1)
         {
-          retval = ovl (result.eigenvalues ());
+          if (m_flag)
+            {
+              FloatComplexDiagMatrix d (result.eigenvalues ());
+              retval = ovl (d);
+            }
+          else
+            {
+              retval = ovl (result.eigenvalues ());
+            }
+        }
+      else if (nargout == 2)
+        {
+          if (v_flag)
+            {
+              retval = ovl (result.right_eigenvectors (), result.eigenvalues ());
+            }
+          else
+            {
+              FloatComplexDiagMatrix d (result.eigenvalues ());
+              retval = ovl (result.right_eigenvectors (), d);
+            }
         }
       else
         {
-          // Blame it on Matlab.
-          FloatComplexDiagMatrix d (result.eigenvalues ());
-
-          retval = ovl (result.eigenvectors (), d);
+          if (v_flag)
+            {
+             retval = ovl (result.right_eigenvectors (), result.eigenvalues (), result.left_eigenvectors ());
+            }
+          else
+            {
+               FloatComplexDiagMatrix d (result.eigenvalues ());
+               retval = ovl (result.right_eigenvectors (), d, result.left_eigenvectors ());
+            }
         }
     }
   else
     {
       EIG result;
 
-      if (nargin == 1)
+      if (AEPcase)
         {
           if (arg_a.is_real_type ())
             {
               tmp_a = arg_a.matrix_value ();
 
-              result = EIG (tmp_a, nargout > 1);
+              result = EIG (tmp_a, nargout > 1, nargout > 2, balance);
             }
           else
             {
               ctmp_a = arg_a.complex_matrix_value ();
 
-              result = EIG (ctmp_a, nargout > 1);
+              result = EIG (ctmp_a, nargout > 1, nargout > 2, balance);
             }
         }
-      else if (nargin == 2)
+      else
         {
           if (arg_a.is_real_type () && arg_b.is_real_type ())
             {
               tmp_a = arg_a.matrix_value ();
               tmp_b = arg_b.matrix_value ();
 
-              result = EIG (tmp_a, tmp_b, nargout > 1);
+              result = EIG (tmp_a, tmp_b, nargout > 1, nargout > 2, force_qz);
             }
           else
             {
               ctmp_a = arg_a.complex_matrix_value ();
               ctmp_b = arg_b.complex_matrix_value ();
 
-              result = EIG (ctmp_a, ctmp_b, nargout > 1);
+              result = EIG (ctmp_a, ctmp_b, nargout > 1, nargout > 2, force_qz);
             }
         }
 
       if (nargout == 0 || nargout == 1)
         {
-          retval = ovl (result.eigenvalues ());
+          if (m_flag)
+            {
+              ComplexDiagMatrix d (result.eigenvalues ());
+              retval = ovl (d);
+            }
+          else
+            {
+              retval = ovl (result.eigenvalues ());
+            }    
+        }
+      else if (nargout == 2)
+        {
+          if (v_flag)
+            {
+              retval = ovl (result.right_eigenvectors (), result.eigenvalues ());
+            }
+          else
+            {
+              ComplexDiagMatrix d (result.eigenvalues ());
+              retval = ovl (result.right_eigenvectors (), d);
+            }
         }
       else
         {
-          // Blame it on Matlab.
-          ComplexDiagMatrix d (result.eigenvalues ());
-
-          retval = ovl (result.eigenvectors (), d);
+          
+          if (v_flag)
+            {
+             retval = ovl (result.right_eigenvectors (), result.eigenvalues (), result.left_eigenvectors ());
+            }
+          else
+            {
+               ComplexDiagMatrix d (result.eigenvalues ());
+               retval = ovl (result.right_eigenvectors (), d, result.left_eigenvectors ());
+            }
         }
     }
 
@@ -213,8 +351,26 @@ The eigenvalues returned by @code{eig} a
 %! assert (d, [-1, 0; 0, 3], sqrt (eps));
 %! assert (v, [-x, x; x, x], sqrt (eps));
 
+%!test
+%! [v, d, w] = eig ([1, 2; 2, 1]);
+%! x = 1 / sqrt (2);
+%! assert (w, [-x, x; x, x], sqrt (eps));
+
+%!test
+%! [v, d] = eig ([1, 2; 2, 1], "balance");
+%! x = 1 / sqrt (2);
+%! assert (d, [-1, 0; 0, 3], sqrt (eps));
+%! assert (v, [-x, x; x, x], sqrt (eps));
+
+%!test
+%! [v, d, w] = eig ([1, 2; 2, 1], "balance");
+%! x = 1 / sqrt (2);
+%! assert (w, [-x, x; x, x], sqrt (eps));
+
 %!assert (eig (single ([1, 2; 2, 1])), single ([-1; 3]), sqrt (eps ("single")))
 
+%!assert (eig (single ([1, 2; 2, 1]), "balance"), single ([-1; 3]), sqrt (eps ("single")))
+
 %!test
 %! [v, d] = eig (single ([1, 2; 2, 1]));
 %! x = single (1 / sqrt (2));
